/*
 * Copyright (C) 2003-2006 Funambol
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

//
// @author Marco Magistrali
// @version $Id: SyncMLDMConfig.cpp,v 1.0 2004/04/27 11:21:00 magi Exp $
//
#ifndef INCL_DM_SYNCMLDMCON
    #define INCL_DM_SYNCMLDMCON

    #include "http/common/Constants.h"
    #include "spds/common/Constants.h"    
    #include "spdm/common/Constants.h"
    #include "spdm/common/ManagementNode.h"
    #include "common/Log.h"

    #define PROPERTY_CON_BEARER     TEXT("Bearer"    )
    #define PROPERTY_CON_ADDRTYPE   TEXT("AddrType"  )
    #define PROPERTY_CON_ADDR       TEXT("Addr"      )
    
    #define INT_VALUESIZE         512
    
    class __declspec(dllexport) SyncMLDMCon {

    private:

        wchar_t bearer      [DIM_CON_BEARER];
        wchar_t addrType    [DIM_CON_ADDRTYPE  ];
        wchar_t addr        [DIM_CON_ADDR  ];
        

    public:
        SyncMLDMCon();
        SyncMLDMCon(ManagementNode* node);              


        wchar_t* getBearer();
        void setBearer(wchar_t* bearer);

        wchar_t* getAddrType();
        void setAddrType(wchar_t* addrType);

        wchar_t* getAddr();
        void setAddr(wchar_t* addr);
     
        /*
         * Reads the configuration from the device manager
         */
        BOOL readFromDM(ManagementNode* node);

        /*
         * Stores the changed information into the device manager.
         * It returns TRUE if the operation was successfull, FALSE otherwise.
         *
         * NOTE: this methods must be mainly developed. For now it stores the sources
         *       last timestamp only. Is TBD to trace which fields are changed and
         *       persists them in the DM as well.
         */
        //BOOL saveToDM();

    };
#endif